#!/usr/athena/bin/perl
#
# Output format:
#
#  HR:MN load15 users newsdf spooldf spool2df groupdf discussd readactv nntpconn
#
$STATFILE='/news/log/stats';
$DREADSTAT='/news/log/dreaderd.status';
$READIP='18.181.0.25';
open(PS, "/usr/bin/ps -ef |");
open(DF, "/usr/bin/df -k /news /news/spool/news /news/spool/news2 /news/spool/group|");
open(NETSTAT, "/usr/bin/netstat -f inet -P tcp |");
open(DREADSTAT, $DREADSTAT);
($sec, $min, $hour) = localtime(time);
$_ = `/usr/bin/uptime`;
($users, $load15) = (/.*(\d+) user.* (\d+.\d+)$/i);
<DF>;
@news_df = split(/[ \t\n]+/, <DF>);
@spool_df = split(/[ \t\n]+/, <DF>);
@spool2_df = split(/[ \t\n]+/, <DF>);
@group_df = split(/[ \t\n]+/, <DF>);
$discussd = 0;
$nntpconn = 0;
$readactv = 0;
<PS>;
while(<PS>) {
  $discussd++ if /bin\/a?discussd/;
}
<NETSTAT>; <NETSTAT>; <NETSTAT>; <NETSTAT>;
while(<NETSTAT>) {
  $nntpconn++ if (/^$READIP\.119\s+/ && /ESTABLISHED/);
}
while(<DREADSTAT>) {
  ($pid, $conn, $status, $vserv, $host, $bits) = split(/\s+/);
  $readactv++ if ($status eq 'ACTV') && ($bits =~ /^.r.$/);
}
close(DREADSTAT);
close(NETSTAT);
close(DF);
close(PS);
open(LOG, ">> $STATFILE");
printf LOG
	"%02d:%02d\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n",
	$hour, $min,
	$load15, $users,
	$news_df[3], $spool_df[3], $spool2_df[3], $group_df[3],
	$discussd, $readactv, $nntpconn;
close(LOG);
